//
//  ViewController.m
//  SimpleTimer
//
//  Created by Christian Faust on 3/5/15.
//  Copyright (c) 2015 Christian Faust. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()


@end

@implementation ViewController
{
    
    BOOL isTimerRunning;
    BOOL isPaused;
    int hours;
    int minutes;
    int seconds;
    
    int secondsCount;
    
    NSTimer *timer;
    
}

@synthesize startStopButton, pauseButton, datePicker, timeLabel;

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    isTimerRunning = NO;
    isPaused = NO;
    pauseButton.enabled = NO;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)startStopButton:(id)sender {
    
    NSTimeInterval duration = datePicker.countDownDuration;
    
    seconds = 0;
    hours = (int)(duration/3600.0f);
    minutes = ((int)duration - (hours * 3600))/60;

    secondsCount = ((hours * 3600) + (minutes * 60));

    timeLabel.text = [NSString stringWithFormat:@"%02i:%02i:%02i", hours, minutes, seconds];
    
    if (isTimerRunning == YES) {
        
        timeLabel.alpha = 0;
        [startStopButton setTitle:@"Start" forState:UIControlStateNormal];
        [pauseButton setTitle:@"Pause" forState:UIControlStateNormal];
        pauseButton.enabled = NO;
        
        [timer invalidate];
        timer = nil;

    } else {
        timeLabel.alpha = 1;
        [startStopButton setTitle:@"Stop" forState:UIControlStateNormal];
        pauseButton.enabled = YES;
        
        if (timer == nil) {
            timer = [NSTimer scheduledTimerWithTimeInterval:1.0
                                                 target:self
                                               selector:@selector(updateTimer)
                                               userInfo:nil
                                                repeats:YES];
        }
        
    }
    
    isTimerRunning = !isTimerRunning;
    
    
}

- (void) updateTimer {
    
    secondsCount--;
    hours = secondsCount/3600;
    minutes = secondsCount/60;
    seconds = secondsCount - (minutes * 60);
    
    timeLabel.text = [NSString stringWithFormat:@"%02i:%02i:%02i", hours, minutes, seconds];
    
    if (secondsCount <= 0) {
        
        [timer invalidate];
        timer = nil;

        timeLabel.alpha = 0;
        [startStopButton setTitle:@"Start" forState:UIControlStateNormal];
        pauseButton.enabled = NO;

    }
    
}

- (IBAction)pauseTimer:(id)sender {
    
    if (isPaused == NO) {
        [timer invalidate];
        timer = nil;
        
        [pauseButton setTitle:@"Resume" forState:UIControlStateNormal];
        
    } else {
        if (timer) {
            [timer invalidate];
            timer = nil;
        }
        timer = [NSTimer scheduledTimerWithTimeInterval:1.0
                                                 target:self
                                               selector:@selector(updateTimer)
                                               userInfo:nil
                                                repeats:YES];
        
        [pauseButton setTitle:@"Pause" forState:UIControlStateNormal];
    }
    
    isPaused = !isPaused;
    
}


@end
